! Eine Library fr Choose Your Own Adventure- bzw. Multiple-Choice-Spiele
! getestet mit Inform 6.21 unter Windows 2000.
! Diese Datei muss nach den Objekten eingebunden werden.

[fontstyle x;
#ifdef TARGET_ZCODE;
    if (x) style bold;
    else style roman;
#ifnot;
    if (x) glk($0086, 1);
    else glk($0086, 0);
    ! Normale (0) oder betonte (1) Schrift
#endif;
];

[readkey done;
#ifdef TARGET_ZCODE;
    @read_char 1 -> done;
    return done;
#ifnot;
    done = false;
    glk($00D2, gg_mainwin);
    while (~~done) {
      glk($00C0, gg_event);
      if (gg_event-->0 == 2 && gg_event-->1 == gg_mainwin) done = true;
    }
    return gg_event-->2;
#endif;
];

#ifdef TARGET_GLULX;

[ GGRecoverObjects id;
    ! If GGRecoverObjects() has been called, all these stored IDs are
    ! invalid, so we start by clearing them all out.
    ! (In fact, after a restoreundo, some of them may still be good.
    ! For simplicity, though, we assume the general case.)
    gg_mainwin = 0;
    gg_savestr = 0;

    id = glk($0040, 0, gg_arguments); ! stream_iterate
    while (id) {
        switch (gg_arguments-->0) {
            GG_SAVESTR_ROCK: gg_savestr = id;
        }
        id = glk($0040, id, gg_arguments); ! stream_iterate
    }

    id = glk($0020, 0, gg_arguments); ! window_iterate
    while (id) {
        switch (gg_arguments-->0) {
            GG_MAINWIN_ROCK: gg_mainwin = id;
        }
        id = glk($0020, id, gg_arguments); ! window_iterate
    }
];

[ GGInitialise res;
    @gestalt 4 2 res; ! Test if this interpreter has Glk.
    if (res == 0) {
      ! Without Glk, we're entirely screwed.
      quit;
    }
    ! Set the VM's I/O system to be Glk.
    @setiosys 2 0;
    GGRecoverObjects();

    ! Now, gg_mainwin and gg_storywin might already be set. If not, set them.

    if (gg_mainwin == 0) {
        ! Open the story window.
        gg_mainwin = glk($0023, 0, 0, 0, 3, GG_MAINWIN_ROCK); ! window_open
        if (gg_mainwin == 0) {
            ! If we can't even open one window, there's no point in going on.
            quit;
        }
    }
    else {
        ! There was already a story window. We should erase it.
        glk($002A, gg_mainwin); ! window_clear
    }
    glk($002F, gg_mainwin); ! set_window
];
#endif;

[Play key real;
  do {
    SetOptions();
    PrintOptions();
    new_line;
    print ">";
    key = readkey();
    if (33>key)  print "*^^"; else {
      if (key>126) print "*^^"; else {
        print (char) key, "^^";  ! Nicht den Wert, sondern das dahinterliegende Zeichen
      };
    };
    switch (key) {           ! Achtung! Key ist der ZSCII-Wert des Buchstabens
      72, 104:  ! H(elp), H(ilfe)
                print "In diesem Spiel musst du nur die Ziffer deiner Wahl eingeben,
                      um Entscheidungen zu treffen. Vor jedem Zug wird angezeigt,
                      welche Zahl fr welche Option steht. Auer den Zahlen von 1 bis 9
                      sind folgende Eingaben mglich:^^";
                      spaces 3; fontstyle(1);; print"H";
                      fontstyle(0);; print " ruft diesen Hilfstext auf,^";
                      spaces 3; fontstyle(1);; print"L";
                      fontstyle(0);; print " zeigt die momentane Lage noch einmal an,^";
                      spaces 3; fontstyle(1);; print"S";
                      fontstyle(0);; print " speichert den aktuellen Spielstand,^";
                      spaces 3; fontstyle(1);; print"W";
                      fontstyle(0);; print " kann einen gespeicherten Spielstand wiederherstellen, und^";
                      spaces 3; fontstyle(1);; print"E";
                      fontstyle(0);; print " beendet das Spiel.^^Im
                      Augenblick stehen folgende Ziffern zur Auswahl:^^";
      48:       print "Bitte gib eine Nummer zwischen 1 und ", nr_valid_options, " ein.^^";
      ! 0
      49 to 57: key=key-48;  ! Hier wird in "echte" Zahlen umgerechnet
      ! 1 - 9
                if (key>nr_valid_options) {
                  print "Bitte gib eine Ziffer zwischen 1 und ", nr_valid_options, " ein.^^";
                }
                else {
                  real = valid_options->key;
                  current_room.exec(real);
                };
      76, 108:  print (string) current_room.text;
      ! L(age), L(ook)
      101, 69:  game_over=true;
      ! E(nd), E(nde)
      83,115:   SaveGame();
      ! S(ave), S(peichern)
      82, 87, 114, 119:
      ! R(estore), W(iederherstellen)
                RestoreGame();
      13,32:    print "Nanu?^^";
      ! Leertaste oder Return
      default:  print "Wie bitte?^^";
    };
  }
  until (game_over);         ! Das Ausdrucken einer Nachricht bleibt dem Objektproperty berlassen
];                           ! CYOA unterscheidet nicht zwischen Gewonnen und Verloren

#ifdef TARGET_ZCODE;
[SaveGame;
  save saved;
  "Speichern nicht mglich.^";
  .saved;
  "O.K.^";
];

[RestoreGame;
  restore restored;
  "Wiederherstellen nicht mglich.^";
  .restored;
  "O.K.^";
];
#ifnot;
[SaveGame res fref;
  fref = glk($0062, $01, $01, 0); ! fileref_create_by_prompt
  if (fref == 0) jump SFailed;
  gg_savestr = glk($0042, fref, $01, GG_SAVESTR_ROCK); ! stream_open_file
  glk($0063, fref); ! fileref_destroy
  if (gg_savestr == 0) jump SFailed;

  @save gg_savestr res;
  if (res == -1) {
    GGRecoverObjects();
    glk($0044, gg_savestr, 0); ! stream_close
    gg_savestr = 0;
    "O.K.^";
  }
  glk($0044, gg_savestr, 0); ! stream_close
  gg_savestr = 0;

  if (res == 0) return "O.K.^";

  .SFailed;
  "Speichern nicht mglich.^";
];

[RestoreGame res fref;
  fref = glk($0062, $01, $02, 0); ! fileref_create_by_prompt
  if (fref == 0) jump RFailed;
  gg_savestr = glk($0042, fref, $02, GG_SAVESTR_ROCK); ! stream_open_file
  glk($0063, fref); ! fileref_destroy

  if (gg_savestr == 0) jump RFailed;
  @restore gg_savestr res;
  glk($0044, gg_savestr, 0); ! stream_close
  gg_savestr = 0;

  .RFailed;
  "Wiederherstellen nicht mglich.^";
];
#endif;

[ClearOptions i;
  ! Setze die Werte-Zuordnung auf Null
  for (i=1:i<=valid_options->0:i++) {
    valid_options->i = 0;
  };
];


[SetOptions displayed maxoption real;    ! Reale und angezeigte Nummern mssen zugeordnet werden
  ClearOptions();                        ! Erst alles lschen
  maxoption = current_room.#option/WORDSIZE;
  real = 0;
  for (displayed=1:displayed<=maxoption:displayed++) {
      do {
        if (real <= maxoption) {
            if (current_room.&active-->real == 1) {
              valid_options->displayed = real;
              nr_valid_options = displayed;
              real++;
              break;
            }
            else real++;
        };
      }
      until (real>maxoption);
  };
];


[PrintOptions i real;
  for (i=1:i<=nr_valid_options:i++) {
    real = valid_options->i;
    print "   ", i, ": ";
    print (string) current_room.&option-->real;
    new_line;
  };
];

[set i j;
  if (j == 0) j = current_room;
  if (i > current_room.#option/WORDSIZE) {
     print "[*** Programmierfehler: Option ", i, " von Objekt ";
     print current_room, " konnte nicht aktiviert werden. Das Objekt ";
     print "hat nur ", current_room.#option/WORDSIZE, " Optionen! ***}]^^";
  };
  j.&active-->i = 1;
];

[unset i j;
  if (j == 0) j = current_room;
  if (i > current_room.#option/WORDSIZE) {
     print "[*** Programmierfehler: Option ", i, " von Objekt ";
     print current_room, " konnte nicht deaktiviert werden. Das Objekt ";
     print "hat nur ", current_room.#option/WORDSIZE, " Optionen! ***]^^";
  };
  j.&active-->i = 0;
];

[goto i;
      current_room=i;
      print (string) current_room.text;
];

[Main;
#ifdef TARGET_GLULX;
  GGInitialise();
#endif;
  Init();
  Play();
  print "Auf Wiedersehen!^^";
];